package cz.muni.fi.pb162.inheritance;

/**
 * Trieda reprezentuje akékoľvek zariadenie, ktoré je poháňané batériou
 * Predstavuje jednoduchý príklad nadtriedy
 */
public class CordlessDevice {

    private final String brand;
    private final String model;
    private int batteryLevel;

    public CordlessDevice(String brand, String model, int batteryLevel) {
        this.brand = brand;
        this.model = model;
        this.batteryLevel = batteryLevel;
    }

    public String getBrand() {
        return brand;
    }

    public String getModel() {
        return model;
    }

    public int getBatteryLevel() {
        return batteryLevel;
    }

    public void charge(int amount) {
        if (!validate(amount, "charge")) {
            return;
        }
        if (amount + batteryLevel <= 100) {
            batteryLevel += amount;
        } else {
            batteryLevel = 100;
        }
    }

    public void discharge(int amount) {
        if (!validate(amount, "discharge")) {
            return;
        }
        if (batteryLevel - amount >= 0) {
            batteryLevel -= amount;
        } else {
            batteryLevel = 0;
        }
    }

    // pomocná funkcia na overenie či zadané množstvo nie je záporné
    protected static boolean validate(int amount, String action) {
        if (amount < 0) {
            System.err.println("Cannot " + action + "negative amount of percent!");
            return false;
        }
        return true;
    }
}
