package cz.muni.fi.pb162.inheritance;

/**
 * Dedičnosť je jedným zo štyroch piliérov OOP
 * Je to spôsob akým je jedna trieda schopná prebrať všetky vlastnosti (metódy a atribúty) z inej triedy
 * Umožnuje tak znovuvyužitie existujúceho kódu v novej triede
 * Dediaca trieda by vždy mala spĺňať vzťah "Is a" - v našej ukážke Phone is a Wireless device
 * Ako nadtriedu označujeme triedu z ktorej sa dedí - v našom príklade je to trieda WireLessDevice
 * Ako podtriedu označujeme triedu ktorá dedí vlastnosti nadtriedy (špecializuje ju) = v našom príklade to je trieda Phone
 */
public class Demo {
    public static void main(String[] args) {

        CordlessDevice device = new CordlessDevice("Dell", "Latitude 5491", 80);

        device.discharge(30);

        Phone phone = new Phone("Samsung", "Galaxy S9", 60, 64);

        // objekt podtriedy (Phone) môže nahradiť objekt nadtriedy (WirelessDevice)
        CordlessDevice samsung = device;
        // stráca tým však metódy, ktoré sa nenachádzajú v nadtriede
        // samsung.getMaxMemoryCapacity(); // po odkomentovani kód nebude možné skompilovať

        // ak použijeme metódu, ktorú sme prepísali (override) v podtriede, využije sa implementácia metódy z podtriedy
        samsung.charge(10);
        System.out.println("Phone is charged on: " + samsung.getBatteryLevel() + "%"); // 80% - využila sa implementácia z podtriedy

        // naopak to nie je možné, objekt nadtriedy (WirelessDevice) nemôže nahradiť objekt podtriedy (Phone);
        // Phone dell = device; // po odkomentovani, kód nebude možné skompilovať
    }
}
