package cz.muni.fi.pb162.inheritance;

import cz.muni.fi.pb162.inheritance.CordlessDevice;

/**
 * Trieda Phone rozširuje triedu CordlessDevice a stáva sa tak jej podtriedou
 * Na to aby trieda rozširovala nejakú triedu sa používa kľúčové slovíčko "extends"
 * Na prístup k metódam nadtriedy sa používa kľúčové slovíčko "super"
 */
public class Phone extends CordlessDevice {

    // brand, model, batteryLevel - poděděno z CordlessDevice
    private final int maxMemoryCapacity;

    public Phone(String brand, String model, int batteryLevel, int maxMemoryCapacity) {
        // v konštruktore podtriedy sa vždy musí zavolať konštruktor nadtriedy

        // konštruktor nadtriedy sa musí zavolať ako prvý v konštruktore podtriedy
        // je to z dôvodu zabránenia práce s neinicializovanými atribútmi
        // ak odkomentujete následujúci riadok, kód nebude možné skompilovať

        // super.getBrand(); -> snažili by sme sa získať neinicializovaný atribút "brand"

        // ak má nadtrieda bezparametrický konštruktor, je zavolaný automaticky

        super(brand, model, batteryLevel); // volanie konštruktoru nadtriedy
        //this.brand = brand;
        this.maxMemoryCapacity = maxMemoryCapacity;
        // brand, model nejsou inicializovany
    }

    public Phone() {
        this("MyBrand", "MyModel", 100, 64);
    }

    public int getMaxMemoryCapacity() {
        return maxMemoryCapacity;
    }

    public void dischargeComplete() {
        discharge(100);
    }

    // ak chceme zmeniť funkcionalitu niektorej metódy z natriedy využijeme anotáciu @Override
    @Override
    public void charge(int amount) {
        validate(20, "nnmm");
        // náš telefón podporuje fast-charge a tak sa nabíja dvojnásobnou rýchlosťou
        // zavoláme tak pôvodnu implementáciu metódy charge v nadtriede ale s dvojnásobným množstvom energie
        super.charge(2 * amount);
    }
}
